using System.Diagnostics;
using System;
using System.Windows.Forms;
using System.Collections;
using System.Drawing;
using Microsoft.VisualBasic;
using System.Data;
using System.Collections.Generic;

//http://www.helmpcb.com/Software/USBHIDVB/USBHIDVB.aspx
//USB HID Template for Visual Basic
//Amr Bekhit



namespace USBTemplate1
{
	public partial class frmUSB
	{
		public frmUSB()
		{
			InitializeComponent();
			
			//Added to support default instance behavour in C#
			if (defaultInstance == null)
				defaultInstance = this;
		}
		
		#region Default Instance
		
		private static frmUSB defaultInstance;
		
		/// <summary>
		/// Added by the VB.Net to C# Converter to support default instance behavour in C#
		/// </summary>
		public static frmUSB Default
		{
			get
			{
				if (defaultInstance == null)
				{
					defaultInstance = new frmUSB();
					defaultInstance.FormClosed += new FormClosedEventHandler(defaultInstance_FormClosed);
				}
				
				return defaultInstance;
			}
		}
		
		static void defaultInstance_FormClosed(object sender, FormClosedEventArgs e)
		{
			defaultInstance = null;
		}
		
		#endregion
		// vendor and product IDs
		private const int VendorID = 0xAAAA; //Replace with your device's
		private const int ProductID = 0xEF04; //product and vendor IDs
		
		// read and write buffers
		private const short BufferInSize = 2; //Size of the data buffer coming IN to the PC - данные от контроллера
		private const short BufferOutSize = 1; //Size of the data buffer going OUT from the PC - данные в контроллер
		byte[] BufferIn = new byte[BufferInSize + 1]; //Received data will be stored here - the first byte in the array is unused
		byte[] BufferOut = new byte[BufferOutSize + 1]; //Transmitted data is stored here - the first item in the array must be 0
		
		// ****************************************************************
		// when the form loads, connect to the HID controller - pass
		// the form window handle so that you can receive notification
		// events...
		//*****************************************************************
		public void Form1_Load(System.Object sender, System.EventArgs e)
		{
			// do not remove!
			HIDDLLInterface.ConnectToHID(this);
		}
		
		//*****************************************************************
		// disconnect from the HID controller...
		//*****************************************************************
		private void Form1_FormClosed(object sender, System.Windows.Forms.FormClosedEventArgs e)
		{
			HIDDLLInterface.DisconnectFromHID();
		}
		
		//*****************************************************************
		// a HID device has been plugged in...
		//*****************************************************************
		public void OnPlugged(int pHandle)
		{
			if (HIDDLLInterface.hidGetVendorID(pHandle) == VendorID && HIDDLLInterface.hidGetProductID(pHandle) == ProductID)
			{
				// ** YOUR CODE HERE **
				
			}
		}
		
		//*****************************************************************
		// a HID device has been unplugged...
		//*****************************************************************
		public void OnUnplugged(int pHandle)
		{
			if (HIDDLLInterface.hidGetVendorID(pHandle) == VendorID && HIDDLLInterface.hidGetProductID(pHandle) == ProductID)
			{
				HIDDLLInterface.hidSetReadNotify(HIDDLLInterface.hidGetHandle(VendorID, ProductID), false);
				// ** YOUR CODE HERE **
				//УСТРОЙСТВО ОТКЛЮЧЕНО
				Label1.Text = "OFF";
			}
		}
		
		//*****************************************************************
		// controller changed notification - called
		// after ALL HID devices are plugged or unplugged
		//*****************************************************************
		public void OnChanged()
		{
			// get the handle of the device we are interested in, then set
			// its read notify flag to true - this ensures you get a read
			// notification message when there is some data to read...
			int pHandle;
			pHandle = HIDDLLInterface.hidGetHandle(VendorID, ProductID);
			HIDDLLInterface.hidSetReadNotify(HIDDLLInterface.hidGetHandle(VendorID, ProductID), true);
		}
		
		//*****************************************************************
		// on read event...
		//*****************************************************************
		public void OnRead(int pHandle)
		{
			// read the data (don't forget, pass the whole array)...
            float byt1;
            float byt2;
            float zamer;
            string temperatura;
			
			if (HIDDLLInterface.hidRead(pHandle, ref BufferIn[0]))
			{
				// ** YOUR CODE HERE **
				// first byte is the report ID, e.g. BufferIn(0)
				// the other bytes are the data from the microcontroller...
				
				//######################################################################################
				// ВЫЧИСЛЕНИЕ ТЕМПЕРАТУРЫ ИЗ ДВУХ ПРИНЯТЫХ БАЙТОВ И ОТОБРАЖЕНИЕ В НЕОБХОДИМОМ ФОРМАТЕ
                byt1 = BufferIn[1];
                byt2 = BufferIn[2];
                zamer = byt1 / 16 + byt2 * 16;
				if (zamer < 150 && zamer > - 50)
				{
					temperatura = Strings.Format(zamer, ".0");
					Label1.Text = temperatura + " °C";
				}
				//######################################################################################
				
			}
		}
		
		
		public void OnWrite(int pHandle)
		{
			// read the data (don't forget, pass the whole array)...
			BufferOut[1] = 255;
			HIDDLLInterface.hidWriteEx(VendorID, ProductID, ref BufferOut[0]);
			//hidWrite(pHandle, BufferOut(0))
			// ** YOUR CODE HERE **
			// first byte is the report ID, e.g. BufferIn(0)
			// the other bytes are the data from the microcontroller...
			
		}
		
	}
	
}
